Помогите с ошибкой при установке пакета

Kubuntu, Xubuntu и другие

Модератор: Модераторы разделов

amid88
Сообщения: 83

Помогите с ошибкой при установке пакета

Сообщение amid88 »

Всем привет! На Ubuntu 18.04 устанавливаю пакет nanovna-saver по инструкции отсюда https://github.com/mihtjel/nanovna-saver
После ввода команды python3.7 -m pip install . выдает ошибку :
Снимок экрана от 2020-06-01 11-09-32.png
У вас нет необходимых прав для просмотра вложений в этом сообщении.
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

Не исключено, что инструкция устарела.
Файл README.md от 24 ноября 2019 года, на тот момент была актуальна версия PyQt5-5.13.2.
А PyQt5-5-15.0, который скачивается у Вас сейчас, появился буквально вчера (1 июня 2020).
Ну или это попросту кривой скрипт.
Я у себя проверить не могу, у меня версия python 3.6.

Кстати, обратите внимание на примечание в инструкции (как раз под приведенной Вами командой):
You may need to install the additional packages python3-distutils, python3-setuptools and python3-wheel for this command to work on some distributions.
P.S. Вывод консоли копируйте как текст, на картинке много чего бывает не видно.
Последний раз редактировалось Hephaestus 02.06.2020 12:20, всего редактировалось 1 раз.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Спасибо большое за помощь, указанные пакеты попробовал установить, пишет что уже установлены. Не знаю что делать ещё ...
Как копировать вывод консоли я не знаю.
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
02.06.2020 11:44
Не знаю что делать ещё ...
Вообще, это изначально не самая хорошая идея - в пакетном дистре ставить что-либо в обход пакетного менеджера. Такой подход чреват разнообразными проблемами, часть этих проблем Вы сейчас увидели лично.
Но это только часть. Поэтому, может, оно и к лучшему, что установка не удалась.
Вот, кстати
amid88 писал(а):
01.06.2020 11:15
устанавливаю пакет nanovna-saver по инструкции
это неверно. Никакой это не пакет.
Пакет был бы файлом с расширением .deb и ставился бы из репов, ну или, на худой конец командой dpkg.
Вот, по-хорошему этот самый deb-пакет и нужно создать для Ubuntu. Но это задача не самая простая.

NanoVNA - это векторный анализатор чего-то там.
Который ещё и нужно собирать, так как в виде пакета его нет.
Интересно, зачем Вам Ubuntu при таких запросах?
amid88 писал(а):
02.06.2020 11:44
Как копировать вывод консоли я не знаю.
Можно выделить мышью текст в окне терминала, скопировать (так же как в текстовом редакторе) и вставить в сообщение. Можно перенаправить вывод команды в файл и скопировать нужный кусок оттуда.
Можно и весь файл прикрепить к сообщению. А можно воспользоваться сервисом вроде pastebin.com, а сюда вставить ссылку. Словом, вариантов много.

Если испытываете трудности с командной строкой, выход один - учиться.
Ubuntu хоть и дружественна к пользователю, но совсем без командной строки не обойтись.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Hephaestus писал:
02.06.2020 12:20
NanoVNA - это векторный анализатор чего-то там.
Который ещё и нужно собирать, так как в виде пакета его нет.
Интересно, зачем Вам Ubuntu при таких запросах?
Этим прибором я постоянно пользуюсь и для него нужна эта программа, но в меня нет компа с виндовс , по этому и стал вопрос установки такой программы на линукс. Я использую комп с убунтой для всех своих нужд и по этому и эту программу хочу установить. В деб. пакете её нет, а как ещё можно её установить ( кроме указанной инструкции не знаю). Может как то можно скомпилировать с кода, но я не знаю.
Какой тогда у меня выход, или выхода нет?
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
02.06.2020 12:35
Этим прибором я постоянно пользуюсь и для него нужна эта программа, но в меня нет компа с виндовс , по этому и стал вопрос установки такой программы на линукс.
Но почему именно Ubuntu?
Линуксов на свете мало что ли?
Ваши задачи явно не для рядового пользователя Ubuntu.
amid88 писал(а):
02.06.2020 12:35
Может как то можно скомпилировать с кода, но я не знаю.
Можно. Но в случае с Ubuntu - это как раз и будет создание пакета.
Причем, возможно, что не одного пакета (с учётом зависимостей).
Рядовой пользователь Ubuntu этим точно заниматься не должен.
amid88 писал(а):
02.06.2020 12:35
Какой тогда у меня выход, или выхода нет?
Выход есть.
Те зависимости, которые пытается вытянуть pip install,
есть в репах Ubuntu. Можно поставить их оттуда. Это пакеты python3-serial, python3-pyqt5, python3-numpy, python3-scipy. Вероятно, потребуются версии для разработчиков pyqt5-dev, libboost-numpy-dev, возможно, какие-то ещё, сразу сказать сложно. Тогда pip install теоретически уже не потребуется.
Но здесь нужно иметь в виду, что в 18.04 python версии 3.6, а для сборки нужно 3.7.
Кстати, в этом, возможно, и кроется причина неудачной сборки у Вас.
Если Вы просто выполняли команды, приведенные в инструкции, то 3.7 у Вас вроде не установится - нет этой версии в 18.04. Она есть в 19.04, а инструкция общая для этих версий, если Вы заметили.
Поэтому Вам нужно либо брать Ubuntu посвежее, либо nanovna-saver постарше (а он есть такой?), либо вообще, брать не Ubuntu, а что-то другое, посерьёзнее.
Если пугает, что другой линукс сложнее, и придётся его изучать, так Вам уже нужно что-то изучать, ибо Вы взялись за задачу, выходящую далеко за рамки обычного пользователя. Но на другом линуксе (который больше подходит для задач сборки) от этого хоть польза будет.

Если же Вы всё-таки каким-то чудом установили python-3.7 на 18.04, то и все зависимости нужно тянуть тем же манером, а это, как я уже сказал, не самый хороший вариант.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Спасибо за столь обширную рекомендацию. Если использовать другой линукс, то какой? И как тогда на другом линуксе установить эту программу, если инструкция только для убунту?
Спасибо сказали:

Аватара пользователя
Bizdelnick
Модератор
Сообщения: 17672
Статус: grammatikführer
ОС: Debian GNU/Linux

Re: Помогите с ошибкой при установке пакета

Сообщение Bizdelnick »

Да можно питоновский хлам в убунте устанавливать, можно. Аккуратно, в домашний каталог. А pyqt5 попробуйте установить дистрибутивный: sudo apt install python3-pyqt5.
Добавлено (14:31):
хотя в данном конкретном случае я бы попробовал все зависимости дистрибутивные поставить: sudo apt install python3-scipy python3-pyqt5 python3-serial python3-numpy. А потом безо всяких pip запустить python3 nanovna-saver.py.
Пишите правильно:
в консоли
вку́пе (с чем-либо)
в общем
вообще
в течение (часа)
новичок
нюанс
по умолчанию
приемлемо
проблема
пробовать
трафик
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
02.06.2020 13:50
Если использовать другой линукс, то какой?
Зависит от многих факторов.
В частности, от Вашей квалификации.

Однако, если нынешняя задача разовая, то можно и на Ubuntu остаться.
Только версию убунты всё равно сменить придется.
amid88 писал(а):
02.06.2020 13:50
И как тогда на другом линуксе установить эту программу
Точно так же как и везде, по той же инструкции.
Но, к примеру, пакет собрать может быть проще.
А может статься, что этот пакет уже существует в другом линуксе.
amid88 писал(а):
02.06.2020 13:50
если инструкция только для убунту?
От убунту там только установка пакетов из репы.
Всё остальное - чисто python-штуки, которые одинаковы везде.

Повторю ещё раз: все эти мои размышления о миграции имеют для Вас смысл только в том случае,
когда таких задач становится несколько.
Один раз python поставили мимо пакетного менеджера, потом какой-нибудь ruby со своим багажом,
потом ещё что-нибудь, потом, спустя какое-то время, обновления прилетели, после которых что-то этого отвалилось... А мы уже и не помним, где чего мы там крутили-вертели...
И тут уже появляется мысль, что неплохо было бы иметь пакет, который ставится и удаляется штатным способом. И мы начинаем осваивать технику создания пакета под свой дистр.
А потом начинается возня уже на уровне пакетов. И дальше весь вопрос в том, насколько быстро надоест собирать/пересобирать пакеты. Потому что Ubuntu - не самый удобный для этого дистр.
Мне на Debian это надоело после второго или третьего пакета.

Если же эта задача у Вас, что называется, один раз в жизни, то можно и так, как сейчас,
но с оглядкой на версии.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

Аватара пользователя
Bizdelnick
Модератор
Сообщения: 17672
Статус: grammatikführer
ОС: Debian GNU/Linux

Re: Помогите с ошибкой при установке пакета

Сообщение Bizdelnick »

Hephaestus писал:
02.06.2020 17:06
Один раз python поставили мимо пакетного менеджера
Откуда такой вывод? ТС утверждает, что действовал по инструкции.
Пишите правильно:
в консоли
вку́пе (с чем-либо)
в общем
вообще
в течение (часа)
новичок
нюанс
по умолчанию
приемлемо
проблема
пробовать
трафик
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

Bizdelnick писал:
02.06.2020 18:37
Откуда такой вывод?
Здесь я имел в виду python в обобщенном смысле, то есть не сам интерпретатор python,
а всякий, как Вы сказали "питоновский хлам" - то, что ставится через pip install.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Всё получилось, правда на Ubuntu 18.04 так и не смог ничего сделать, а вот на Ubuntu 19.10 всё получилось очень легко.
На только что установленную Ubuntu 19.10 установил только

sudo apt install python3-scipy python3-pyqt5 python3-serial python3-numpy (по вашей рекомендации) и конечно
git clone https://github.com/mihtjel/nanovna-saver

больше ничего не устанавливал и запуск
python3.7 nanovna-saver.py

Огромное Вам спасибо!!! Вы очень грамотный человек в этом деле. Вы мне очень помогли.
Всех благ Вам!!!
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Прошу прощения, возник ещё вопрос на эту тему. Нашел в инете готовые rpm. пакеты для этой программы, пакеты для каждой версии Федоры, наверное разработчики пользуются Федорой. Что Вы можете порекомендовать по этому поводу. Так же и другие программы, которыми я пользуюсь в Убунту есть для Федоры. Может есть смысл перейти на Федору?
Спасибо!
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
04.06.2020 09:57
Что Вы можете порекомендовать по этому поводу.
Я рекомендую не суетиться.
Пакеты, которые Вам нужны, должны быть в репах Fedora и никак иначе.
А если Вы их нашли на просторах интернета, например на rpmbone.net,
то нужно внимательно смотреть, что именно там нашлось (какая версия пакета, зависимости, архитектура и пр.).
amid88 писал(а):
04.06.2020 09:57
Так же и другие программы, которыми я пользуюсь в Убунту есть для Федоры.
Большинство программ есть для самых разных дистров, в этом нет ничего удивительного.
amid88 писал(а):
04.06.2020 09:57
Может есть смысл перейти на Федору?
В данном случае нужный Вам пакет обнаруживается на сторонних поисковиках, а в репах я его не увидел. Хотя допускаю, что я плохо искал, пакет упоминается в багзилле RedHat.
Таким образом, может оказаться, что установив Fedora, Вы нужного пакета там не найдете.
И что тогда? Будем переходить с Fedore ещё куда-нибудь? На мой взгляд, беготня с дистра на дистр в погоне за пакетом - это не вариант. Выбор дистра, следует основывать на различных его характеристиках: binary-based или source-based, схема релизов, формат пакетов, состав пакетов, насколько свежие версии софта. То есть наличие нужных пакетов - это безусловно важный фактор, но далеко не единственный. Большинство пакетов есть во всех крупных дистрах.
Последний раз редактировалось Hephaestus 04.06.2020 11:30, всего редактировалось 1 раз.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

Аватара пользователя
Bizdelnick
Модератор
Сообщения: 17672
Статус: grammatikführer
ОС: Debian GNU/Linux

Re: Помогите с ошибкой при установке пакета

Сообщение Bizdelnick »

Hephaestus писал:
04.06.2020 10:55
В данном случае нужный Вам пакет обнаруживается на сторонних поисковиках, а в репах я его не увидел. Хотя допускаю, что я плохо искал, пакет упоминается в багзилле RedHat.
Плохо. https://src.fedoraproject.org/rpms/nanovna-saver
Повод ли это менять дистрибутив — не знаю. Попробовать можно, а потом уже по итоговым впечатлениям принимать окончательное решение. И учитывать при этом, что у Fedora нет LTS-релизов, так что надо будет постоянно обновляться, получая, помимо свежего софта, ещё и свежие баги.
Пишите правильно:
в консоли
вку́пе (с чем-либо)
в общем
вообще
в течение (часа)
новичок
нюанс
по умолчанию
приемлемо
проблема
пробовать
трафик
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

Bizdelnick писал:
04.06.2020 11:23
Попробовать можно, а потом уже по итоговым впечатлениям принимать окончательное решение.
Для новичка это чересчур хлопотно, по-моему.
Человек явно пришёл с винды, а там такого разнообразия нет: винда всегда одна и та же.
Но если уж ставить "на посмотреть", то куда-нибудь в виртуалку, или дуалбутом, на худой конец.
Мало ли, железяка там какая-нибудь не взлетит...
Добавлено (11:51):
amid88
Обрисуйте круг задач, которые Вам нужно выполнять.
Любимые программы назовите, если такие есть.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Hephaestus писал:
04.06.2020 11:36
Bizdelnick писал:
04.06.2020 11:23
Попробовать можно, а потом уже по итоговым впечатлениям принимать окончательное решение.
Для новичка это чересчур хлопотно, по-моему.
Человек явно пришёл с винды, а там такого разнообразия нет: винда всегда одна и та же.
Но если уж ставить "на посмотреть", то куда-нибудь в виртуалку, или дуалбутом, на худой конец.
Мало ли, железяка там какая-нибудь не взлетит...
Добавлено (04.06.2020 11:51):
amid88
Обрисуйте круг задач, которые Вам нужно выполнять.
Любимые программы назовите, если такие есть.
Да нет, винду я забросил очень давно, пробовал разные линуксы и это было то же очень давно. Остался на Убунте , но простым пользователем, так как по моему не требует затрат времени и знаний. Необходимый мне софт есть во всех линуксах, но для радио мне надо пару программ, с которыми проблемы. Если и собирают пакеты, то обычно для Убунту, как самой популярной.
В данный момент мне нужны две программы: WSJT-X и nanovna-saver. С первой проблем нет, а вот со второй деб. пакетов нет а установить на Ubuntu 18.04 не получается, но с Вашей помощью установил и нормально работает на Ubuntu 19.10 или Ubuntu 20.04 , но на обоих что то не так с системой ( тему создал выше, но никто не ответил), На обоих системах не открывается НАСТРОЙКИ, вернее открывается, на панеле значок появляется, а окно не открывается и не возможно сделать любые настройки.
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
04.06.2020 13:42
Да нет, винду я забросил очень давно, пробовал разные линуксы и это было то же очень давно. Остался на Убунте , но простым пользователем, так как по моему не требует затрат времени и знаний.
Тогда Вам мигрировать нет никакого смысла. Вы уже давно сделали свой выбор.
Я-то говорил о миграции в плане сборки пакетов из исходников: если таких много, то нужно выбрать дистр, где сборка наиболее удобна. А в Вашем случае такой задачи нет, как я теперь понимаю.
amid88 писал(а):
04.06.2020 13:42
тему создал выше, но никто не ответил
Там слишком мало сведений.
На первый взгляд похоже на то, что окно открыто, но свёрнуто (или на заднем плане).
Тогда щелчок по значку должен его развернуть/вывести на первый план.
Больше пока ничего предположить не могу.
Опишите в той теме подробнее:
как именно пытаетесь открыть настройки,
реагирует ли появившийся на панели значок на щелчок мыши,
есть ли ошибки в логах,
с какими окнами ещё есть такая проблема (если есть).
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Hephaestus писал:
04.06.2020 17:44
Тогда Вам мигрировать нет никакого смысла. Вы уже давно сделали свой выбор.
Я-то говорил о миграции в плане сборки пакетов из исходников: если таких много, то нужно выбрать дистр, где сборка наиболее удобна. А в Вашем случае такой задачи нет, как я теперь понимаю.
Я когда то пробовал Gentoo , где то год пользовался системой, но что касается программ для радио, ничего найти не мог. Из за этого вернулся на Ubuntu, а сегодня очень удивился, когда при поиске nanovna-saver обнаружил очень большую группу программ для радио, где есть и нужные мне. Удивили то , что это для Gentoo... https://packages.gentoo.org/categories/net-wireless
даже не знаю, может стоит ещё раз попробовать?
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
04.06.2020 18:04
Я когда то пробовал Gentoo , где то год пользовался системой
Вы год пользовались Gentoo и при этом
amid88 писал(а):
02.06.2020 11:44
Как копировать вывод консоли я не знаю.
Это выглядит немного странно, честно говоря.
amid88 писал(а):
04.06.2020 18:04
даже не знаю, может стоит ещё раз попробовать?
Это только Вы можете решить.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Hephaestus писал:
04.06.2020 18:22
Это выглядит немного странно, честно говоря.
Извините, ничего странного, я же писал, что не изучал линукс , а простой пользователь. Да, собирал Gentoo ( причём в то время интернета дома не было), приходилось "ходить на интернет" . Собирал раз 20 или больше, там действительно всё делается в консоле, все команды знал почти наизусть. Если возникали ошибки ,приходилось очень тяжело , особенно с этими флагами и пересборкой ядра и т.д. Это было давно, много забыл уже. Сейчас какие то команды выполняю в консоле, но всего не знаю, так как не изучал. Вообще то Gentoo нравиться, но очень мало знаний в этой области и на обслуживание системы уходило все время, а уже пользоваться было некогда.
Ещё пробовал Slackware, это вообще по моему настоящий линукс, очень понравилась система , если бы было время изучать, изучал бы только
Slackware.
Да, винду бросил когда NT 2000 умер и майкрософт создали смесь бульдога с носорогом и назвали XP. В то время первым моим линуксом был Mandrake. Вот теперь , на старости лет вообще запутался, извините.
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
04.06.2020 19:38
я же писал, что не изучал линукс , а простой пользователь.
Человек, который успешно ставит Gentoo (неважно, с какой попытки)
и пользуется ей около года - это однозначно больше, чем простой пользователь.
amid88 писал(а):
04.06.2020 19:38
Ещё пробовал Slackware, это вообще по моему настоящий линукс, очень понравилась система
Это да. Я выбрал именно её, а не Gentoo.
amid88 писал(а):
04.06.2020 19:38
В то время первым моим линуксом был Mandrake.
Я на линуксы перешёл на несколько лет позже и Mandrake как-то уже не застал.
Но начинал с его потомков, можно сказать.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Hephaestus писал:
04.06.2020 19:55
Это да. Я выбрал именно её, а не Gentoo.
Если честно, я Вам завидую Slackware знать это не каждому дано...
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

amid88 писал(а):
04.06.2020 20:06
Если честно, я Вам завидую Slackware знать это не каждому дано...
Гентушник завидует слакварщику. Дожили...
Я Slackware не знаю, я просто на ней сижу.
На самом деле я присматривался к Gentoo ещё будучи на Debian, но меня сдерживали большой объем английского текста Handbook и перспектива сутками компилять софт на моём слабеньком железе.
А позднее, когда и железо было уже другое, и русский Handbook как раз обновился, я уже выбрал Slackware.
И почитав Gentoo Handbook ради интереса, я к своему удивлению ничего нового для себя уже не обнаружил.
Сборка - она и есть сборка. Так что зависть Ваша напрасна: практически всё, чем Вас манит Slackware, у Вас уже было в Gentoo.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

amid88
Сообщения: 83

Re: Помогите с ошибкой при установке пакета

Сообщение amid88 »

Hephaestus писал:
04.06.2020 20:20
Гентушник завидует слакварщику. Дожили...
Гентушник это не про меня, мне ещё далеко. Просто очень хотелось и делал но сам понимал очень мало. Всё приходилось искать в интернете.
За год немного научился, но всё равно было очень тяжело. Появлялась новая ошибка, не знакомая и опять кошмар...
Не выдержал.
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

Так. Сначала пару слов о том, почему не взлетело с зависимостями из репов.
Насколько я понял, там получается "cannot import QtWidgets" или что-то в этом роде.
А всё потому, что завязано там всё на python3.6, а для сборки нужен python3.7.
Если запустить интепретатор python3.7
и выполнить from PyQt5 import QtWidgets
то получится та же самая ошибка: "cannot import".
А если просто запустить python3,
то запустится python3.6 и команда импорта нормально выполнится.

Была мысль пересобрать пакет PyQt5 из репов с привлечением к сборке python3.7.
Или вообще собрать новый пакет.
Ни одно, ни другое не получилось по той же причине: все пути, хедеры и прочие зависимости дергают 3.6,
а для 3.7 нужных хедеров нет, например, он вообще какой-то урезанный.

Остается один вариант: собирать и ставить с помощью pip по инструкции.
Но здесь всё завершается ошибкой из стартового поста.
Для устранения ошибки нужно обновить pip.

Итак, порядок действий:
1. Удаляем зависимости, которые ранее ставили из репов, если есть.
Как минимум нужно удалить numpy, иначе дальше будет конфликт при запуске.
apt-get remove --purge python3-numpy.
Вместе с ним удалится также и python3-scipy.
Вероятно, нужно удалить и pyserial.

2. Обновляем pip
python3.7 -m pip install --user --upgrade pip

Дальнейше действия такие же как в инструкции:

3. Получаем исходники и переходим в каталог.
git clone https://github.com/mihtjel/nanovna-saver
cd nanovna-saver

4. Запускаем сборку/установку.
python3.7 -m pip install .

5. И наконец, запускаем программу
python3.7 nanovna-saver.py

У меня программа запустилась, но как будет работать, не знаю.

Ставится вся эта музыка в /home/$USER/.local.
В процессе сборки будет предупреждение, что скомпилированные файлы, установлены в .local и недоступны для запуска напрямую,
поскольку эти пути отсутствуют в $PATH.
Это значит, нужно либо добавлять туда эти пути,
либо запускать с указанием путей.

Удалять всё это хозяйство при случае нужно будет с помощью pip uninstall.
А для этого нужно знать, какие компоненты установились в процессе сборки.
В частности поэтому данный способ мне категорически не нравится.
По-хорошему, надо бы всё это обернуть в пакет, но не получилось.

Мысленно, сравнил со Slackware, где установка производится во временный каталог, который является временным корнем,
и упаковывается в пакет. При установке этого пакета файлы просто раскладываются по местам.
При этом по большому счету неважно, собираем мы с помощью autotools, cmake или pip,
схема везде получается одна и та же.

Возможно, в Debian тоже можно было бы раскидать файлы по каталогам во временном корне,
а потом упаковать в пакет, но простых способов я не нашёл.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

Аватара пользователя
Bizdelnick
Модератор
Сообщения: 17672
Статус: grammatikführer
ОС: Debian GNU/Linux

Re: Помогите с ошибкой при установке пакета

Сообщение Bizdelnick »

Hephaestus писал:
06.06.2020 14:06
Возможно, в Debian тоже можно было бы раскидать файлы по каталогам во временном корне,
а потом упаковать в пакет, но простых способов я не нашёл.
Вы не поверите, но именно это делает dpkg-buildpackage. (Нет, если не хочется совсем никакой автоматики, а только руками всё делать, то есть dpkg-deb -b, конечно…)
Пишите правильно:
в консоли
вку́пе (с чем-либо)
в общем
вообще
в течение (часа)
новичок
нюанс
по умолчанию
приемлемо
проблема
пробовать
трафик
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

Bizdelnick писал:
06.06.2020 14:42
Вы не поверите, но именно это делает dpkg-buildpackage.
Почему не поверю? Поверю.
Только я не знаю, как это применить к данному случаю.
Могут ли dpkg-buildpackage и pip install работать в связке?
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали:

Аватара пользователя
Bizdelnick
Модератор
Сообщения: 17672
Статус: grammatikführer
ОС: Debian GNU/Linux

Re: Помогите с ошибкой при установке пакета

Сообщение Bizdelnick »

Hephaestus писал:
06.06.2020 15:35
Могут ли dpkg-buildpackage и pip install работать в связке?
Могут, конечно, если прописать вызов pip install в debian/rules.
Пишите правильно:
в консоли
вку́пе (с чем-либо)
в общем
вообще
в течение (часа)
новичок
нюанс
по умолчанию
приемлемо
проблема
пробовать
трафик
Спасибо сказали:

Аватара пользователя
Hephaestus
Сообщения: 3482
Статус: Многоуважаемый джинн...
ОС: Slackware64-14.1/14.2

Re: Помогите с ошибкой при установке пакета

Сообщение Hephaestus »

Bizdelnick
Значит, всё, что там pip install насобирает, можно загнать в пакет?
Это было бы неплохо. Но я с этим возиться не буду.
ТС этим вряд ли заинтересуется, а мне оно вообще не нужно.
Пускай скрипят мои конечности.
Я - повелитель бесконечности...
Мой блог
Спасибо сказали: